<template>
    <h1>File Upload</h1>
    <form @submit.prevent="uploadFile">
        <input type="file" @change="setFile" accept="image/*"/>
        <button type="submit">Hochladen</button>
    </form>
</template>

<script setup>
    import { ref } from 'vue'
    import axios from 'axios'

    const file = ref(null)

    const updatedUserData = ref({
        "email": "david@ists-wurscht.at",
        "username": "schwarzdavid",
        "firstName": "David",
        "lastName": "Schwarz"
    })

    async function uploadFile() {
        await userStore.updateUser(updatedUserData.value, file.value)
    }

    function setFile(event) {
        console.log(event.target.files)
        file.value = event.target.files[0] || null
    }

    // This function exists in store
    const userStore = {
        currentUser: null,
        async updateUser(updatedUserData, image) {
            if (image) {
                const formData = new FormData()
                formData.set('image', image.value)
                await axios.post('https://codersbay.a-scho-wurscht.at/api/user/image', formData)
            }

            const user = await axios.put('https://codersbay.a-scho-wurscht.at/api/user', updatedUserData)
            this.currentUser = user.data
        }
    }
</script>
